QGIS Application - Bug report #19674
Method theme() of QgsMapCanvas not in sync?
2018-08-23 11:40 AM - Darius G.

Status: Closed

Priority: Normal

Assignee:

Category: Python bindings / sipify

Affected QGIS version:3.4.3 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 27499
Description

iface.mapCanvas().theme() refers always to an empty string while user set map themes in the QGIS GUI interactively.

In addition you can also check this:

https://gis.stackexchange.com/questions/293507/how-to-read-out-which-map-theme-is-used-in-qgis-3

Related issues:
Related to QGIS Application - Feature request # 19769: Add a variable returni... Open 2018-09-04

History

#1 - 2018-09-11 05:21 PM - Adam Szieberth
Connects to #19769
It is weird that ggc.QgsProject.instance().mapThemeCollection() can provide the list of map themes and can emit a signal when map theme changed but

can not give the current/active/actual map theme. Also | found applyTheme() overcomplicated as | would expect to give the name as a single argument and
see the theme changed.

#2 - 2018-09-11 05:45 PM - Jiirgen Fischer

- Related to Feature request #19769: Add a variable returning the current map theme added

#3 - 2018-11-02 12:02 PM - Darius G.

| have installed latest QGIS 3.4 and | have noticed that the bug is still not solved in this version?

#4 - 2018-11-02 01:35 PM - Giovanni Manghi

- Affected QGIS version changed from 3.2.2 to 3.4.0

#5 - 2018-12-05 04:18 PM - Darius G.

Bug still in QGIS 3.4.2 not solved.

#6 - 2018-12-05 05:53 PM - Giovanni Manghi

- Affected QGIS version changed from 3.4.0 to 3.4.2
- Category changed from Python plugins to Python bindings / sipify
https://gis.stackexchange.com/questions/293507/how-to-read-out-which-map-theme-is-used-in-qgis-3

#7 - 2019-01-09 10:05 AM - Darius G.

Bug still in QGIS 3.4.3 not solved.

#8 - 2019-01-09 10:06 AM - Giovanni Manghi

- Affected QGIS version changed from 3.4.2 to 3.4.3

#9 - 2019-02-05 11:57 AM - Darius G.

Bug still in QGIS 3.4.4 not solved...

#10 - 2019-02-26 11:57 AM - Martin Dobias

The main map canvas is "special” - it does not have map theme assigned. Instead when you pick a map theme, styles of map layers are modified according
to the theme's settings. The theme attribute in QgsMapCanvas is used for other map canvases where user want to follow a specific map theme which is
different from the current one.

So in fact this is not a bug, but | understand there's some confusion due to the way how the implementation works.

To figure out the current map theme (and that's how the map themes menu in qgis does it) is like this:

1. get the current state using QgsMapThemeCollection::createThemeFromCurrentState( root, model ) (root and model come from QgsProject::instance())

2. go through the map themes QgsProject::instance()->mapThemeCollection()->mapThemes() and for each have a look at their content
QgsProject:instance()->mapThemeCollection()->mapThemeState( name ) and compare it to the current theme's content

#11 - 2019-02-26 02:34 PM - Darius G.
- Status changed from Open to Closed

Thank you very much for the feedback. | have implemented your procedure and it works.

#12 - 2019-03-01 07:58 PM - Giovanni Manghi

- Resolution set to invalid
